#! /usr/bin/perl

use strict;
use warnings;

my %buckets = ();

while (<>) {
	chomp;
	my (@x) = split /\s+/, $_;

	my $num_packets = scalar @x;
	my $num_drops = grep { /\*/ } @x;

	$buckets{$num_packets}->{'num_bursts'}++;
	$buckets{$num_packets}->{'num_drops'} += $num_drops;
	if ($num_drops > 0) {
		$buckets{$num_packets}->{'bursts_with_drops'}++;
	}
}

for my $n (sort { $a <=> $b } keys %buckets) {
	my $num_bursts = $buckets{$n}->{'num_bursts'} // 0;
	my $num_drops = $buckets{$n}->{'num_drops'} // 0;
	my $bursts_with_drops = $buckets{$n}->{'bursts_with_drops'} // 0;

	my $drop_rate = $num_drops / ($n * $num_bursts);
	my $drop_event_rate = $bursts_with_drops / $num_bursts;
	printf "%3d: drop_rate %.5f  drop_event_rate %.5f\n",
		$n, $drop_rate, $drop_event_rate; 
}
